import javax.swing.*;
import java.awt.event.*;
import java.awt.*;



public class MouseListener extends MouseAdapter  {
   private MyWorld world;
   private Drawable currentElement;
   private JPanel panel;
  
   public MouseListener (MyWorld w, JPanel p){
      world = w;
      panel = p;
   } 

   public void mouseMoved(MouseEvent e) {
      Drawable newElement = world.find(e.getX(), e.getY());
     
      if (newElement == currentElement) return;
      if (currentElement != null) {
         currentElement.setReleased();
         currentElement = null;    
      }
      if (newElement != null) { 
         currentElement = newElement;
         currentElement.setSelected();       
      }
 
      panel.repaint();
   }
  
public void mouseDragged(MouseEvent e) {

      if (currentElement == null) return;
      currentElement.dragTo(e.getX(), e.getY());
      panel.repaint();
      
   }
   public void mouseReleased(MouseEvent e) {
      if (currentElement != null) 
         currentElement.setReleased();
      //para cuando se selecciona 'Eliminar' del menu. 
      //Para poder realizar las operaciones asociadas a la accion
     if(panel.getCursor().equals(Cursor.getPredefinedCursor(Cursor.CROSSHAIR_CURSOR))){
    	 world.removeElement((PhysicsElement)currentElement);
    	 panel.setCursor(Cursor.getDefaultCursor());
       }
   //para cuando se selecciona 'Edit Element' del menu.
     //Para poder realizar las operaciones asociadas a la accion
     if(panel.getCursor().equals(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR))){
      world.editElement((PhysicsElement)currentElement);
      panel.setCursor(Cursor.getDefaultCursor());
     }
      if (!(currentElement instanceof GSpring)&& !(currentElement instanceof GElastic)) {
         currentElement = null;
         return;
      }
     
          // we dragged an attachable element
          // we dragged a spring, so we look for and attachable element near by  
      AttachableElement element = world.findAttachableElement(e.getX(), e.getY());
      if (element == null) {
         currentElement = null;
         return;
      }
      // we dragged a spring and it is near an attachable element,
      // so we hook them to the right spring end.
      if ((currentElement instanceof GSpring)){
    GSpring spring = (GSpring) currentElement;
    Vector2D a1=spring.getAendPosition();
    if ((a1.getX()==e.getX()) && (a1.getY()==e.getY()))
        spring.attachAend(element);
    Vector2D b1=spring.getBendPosition();
    if ((b1.getX()==e.getX()) && (b1.getY()==e.getY()))
        spring.attachBend(element);
    currentElement = null;
    panel.repaint();  
      }
      // mismo metodo de enganche que se uso con el resorte
      if ((currentElement instanceof GElastic)){
    GElastic elastic = (GElastic) currentElement;
       Vector2D a=elastic.getAendPosition();
       if ((a.getX()==e.getX()) && (a.getY()==e.getY()))
          elastic.attachAend(element);
       Vector2D b=elastic.getBendPosition();
       if ((b.getX()==e.getX()) && (b.getY()==e.getY()))
         elastic.attachBend(element);
       
       currentElement = null;
       panel.repaint();  
      }
      
      
      
   }
}